/*
 * Hardware.h
 *
 * Created: 10.04.2014 21:51:40
 *  Author: DL8NCI
 */ 


#ifndef __HARDWARE
#define __HARDWARE __HARDWARE

#include "helpers.h"
//#include "I2C.h"


// relay Lx - on means short; off means open
#define REL_LX_OUT				TWI_AUX_1
#define REL_LX_BIT				1
#define REL_LX_OFF				I2C_sbi(REL_LX_OUT,REL_LX_BIT);
#define REL_LX_ON				I2C_cbi(REL_LX_OUT,REL_LX_BIT);

// relay L3 (47 uH) - on means short; off means open
#define REL_L3_OUT				TWI_AUX_1
#define REL_L3_BIT				0
#define REL_L3_OFF				I2C_sbi(REL_L3_OUT,REL_L3_BIT);
#define REL_L3_ON				I2C_cbi(REL_L3_OUT,REL_L3_BIT);

// relay 330 pF
#define REL_330_OUT				TWI_AUX_1
#define REL_330_BIT				4
#define REL_330_OFF				I2C_sbi(REL_330_OUT,REL_330_BIT);
#define REL_330_ON				I2C_cbi(REL_330_OUT,REL_330_BIT);

// relay 1 kOhm
#define REL_1K_OUT				TWI_AUX_1
#define REL_1K_BIT				3
#define REL_1K_OFF				I2C_sbi(REL_1K_OUT,REL_1K_BIT);
#define REL_1K_ON				I2C_cbi(REL_1K_OUT,REL_1K_BIT);

// relay 33 kOhm
#define REL_33K_OUT				TWI_AUX_1
#define REL_33K_BIT				6
#define REL_33K_OFF				I2C_sbi(REL_33K_OUT,REL_33K_BIT);
#define REL_33K_ON				I2C_cbi(REL_33K_OUT,REL_33K_BIT);

// relay 1 MOhm
#define REL_1M_OUT				TWI_AUX_1
#define REL_1M_BIT				2
#define REL_1M_OFF				I2C_sbi(REL_1M_OUT,REL_1M_BIT);
#define REL_1M_ON				I2C_cbi(REL_1M_OUT,REL_1M_BIT);

// relay NE555
#define REL_NE555_OUT			TWI_AUX_1
#define REL_NE555_BIT			5
#define REL_NE555_OFF			I2C_sbi(REL_NE555_OUT,REL_NE555_BIT);
#define REL_NE555_ON			I2C_cbi(REL_NE555_OUT,REL_NE555_BIT);

// relay LM311
#define REL_LM311_OUT			TWI_AUX_1
#define REL_LM311_BIT			7
#define REL_LM311_OFF		    I2C_sbi(REL_LM311_OUT,REL_LM311_BIT);
#define REL_LM311_ON			I2C_cbi(REL_LM311_OUT,REL_LM311_BIT);






// UI-element zero-LED
#define ZERO_LED_OUT			TWI_AUX_2
#define ZERO_LED_BIT			1
#define ZERO_LED_HIGH			I2C_sbi(ZERO_LED_OUT,ZERO_LED_BIT);
#define ZERO_LED_LOW			I2C_cbi(ZERO_LED_OUT,ZERO_LED_BIT);


// UI-element zero-key
#define ZERO_KEY_OUT			TWI_AUX_2
#define ZERO_KEY_BIT			0
#define ZERO_KEY_DIR_IN			;
#define ZERO_KEY_HIGH			I2C_sbi(ZERO_KEY_OUT,ZERO_KEY_BIT);
#define ZERO_KEY_TEST			I2C_tbi(TWI_AUX_2,ZERO_KEY_BIT);

//#define ZERO_KEY_OUT			PORTA
//#define ZERO_KEY_IN			PINA
//#define ZERO_KEY_DDR			DDRA
//#define ZERO_KEY_BIT			7
//#define ZERO_KEY_DIR_IN		cbi(ZERO_KEY_DDR,ZERO_KEY_BIT);
//#define ZERO_KEY_HIGH			sbi(ZERO_KEY_OUT,ZERO_KEY_BIT);
//#define ZERO_KEY_TEST			ZERO_KEY_IN & (1 << ZERO_KEY_BIT)


// AUX2-Interrupt
#define AUX2_INT_OUT			PORTD
#define AUX2_INT_IN				PIND
#define AUX2_INT_DDR			DDRD
#define AUX2_INT_BIT			2
#define AUX2_INT_DIR_IN			cbi(AUX2_INT_DDR,AUX2_INT_BIT);
#define AUX2_INT_HIGH			sbi(AUX2_INT_OUT,AUX2_INT_BIT);
#define AUX2_INT_TEST			AUX2_INT_IN & (1 << AUX2_INT_BIT)


// USART RTS
//#define USART_RTS_OUT		PORTA
//#define USART_RTS_IN		PINA
//#define USART_RTS_DDR		DDRA
//#define USART_RTS_BIT		7

//#define USART_RTS_DIR_OUT	sbi(USART_RTS_DDR,USART_RTS_BIT);
//#define USART_RTS_DIR_IN	cbi(USART_RTS_DDR,USART_RTS_BIT);
//#define USART_RTS_HIGH		sbi(USART_RTS_OUT,USART_RTS_BIT);
//#define USART_RTS_LOW		cbi(USART_RTS_OUT,USART_RTS_BIT);
//#define USART_RTS_TEST		USART_RTS_IN & ( 1 << USART_RTS_BIT)

/*
// USART CTS
#define USART_CTS_OUT		PORTA
#define USART_CTS_IN		PINA
#define USART_CTS_DDR		DDRA
#define USART_CTS_BIT		6

#define USART_CTS_DIR_OUT	sbi(USART_CTS_DDR,USART_CTS_BIT);
#define USART_CTS_DIR_IN	cbi(USART_CTS_DDR,USART_CTS_BIT);
#define USART_CTS_HIGH		sbi(USART_CTS_OUT,USART_CTS_BIT);
#define USART_CTS_LOW		cbi(USART_CTS_OUT,USART_CTS_BIT);
#define USART_CTS_TEST		USART_CTS_IN & ( 1 << USART_CTS_BIT)
*/



// NE555-reset
#define NE555_RESET_OUT				PORTC
#define NE555_RESET_IN				PINC
#define NE555_RESET_DDR				DDRC
#define NE555_RESET_BIT				3

#define NE555_RESET_DIR_OUT			sbi(NE555_RESET_DDR,NE555_RESET_BIT);
#define NE555_RESET_HIGH			sbi(NE555_RESET_OUT,NE555_RESET_BIT);
#define NE555_RESET_LOW				cbi(NE555_RESET_OUT,NE555_RESET_BIT);

// NE555-trigger
#define NE555_TRIGGER_OUT			PORTD
#define NE555_TRIGGER_IN			PIND
#define NE555_TRIGGER_DDR			DDRD
#define NE555_TRIGGER_BIT			5

#define NE555_TRIGGER_DIR_OUT		sbi(NE555_TRIGGER_DDR,NE555_TRIGGER_BIT);
#define NE555_TRIGGER_HIGH			sbi(NE555_TRIGGER_OUT,NE555_TRIGGER_BIT);
#define NE555_TRIGGER_LOW			cbi(NE555_TRIGGER_OUT,NE555_TRIGGER_BIT);

/*
// NE555-out
#define NE555_OUT_OUT		PORTD
#define NE555_OUT_IN		PIND
#define NE555_OUT_DDR		DDRD
#define NE555_OUT_BIT		6

#define NE555_OUT_DIR_OUT	sbi(NE555_OUT_DDR,NE555_OUT_BIT);
#define NE555_OUT_DIR_IN	cbi(NE555_OUT_DDR,NE555_OUT_BIT);
#define NE555_OUT_HIGH		sbi(NE555_OUT_OUT,NE555_OUT_BIT);
#define NE555_OUT_LOW		cbi(NE555_OUT_OUT,NE555_OUT_BIT);
#define NE555_OUT_TEST		NE555_OUT_IN & ( 1 << NE555_OUT_BIT)
*/

/*
// NE555-Cx
#define NE555_CX_OUT		PORTA
#define NE555_CX_IN			PINA
#define NE555_CX_DDR		DDRA
#define NE555_CX_BIT		3

#define NE555_CX_DIR_OUT	sbi(NE555_CX_DDR,NE555_CX_BIT);
#define NE555_CX_DIR_IN		cbi(NE555_CX_DDR,NE555_CX_BIT);
#define NE555_CX_HIGH		sbi(NE555_CX_OUT,NE555_CX_BIT);
#define NE555_CX_LOW		cbi(NE555_CX_OUT,NE555_CX_BIT);
#define NE555_CX_TEST		NE555_CX_IN & ( 1 << NE555_CX_BIT)
*/

/*
// LM311-out
#define LM311_OUT_OUT		PORTB
#define LM311_OUT_IN		PINB
#define LM311_OUT_DDR		DDRB
#define LM311_OUT_BIT		1

#define LM311_OUT_DIR_OUT	sbi(LM311_OUT_DDR,LM311_OUT_BIT);
#define LM311_OUT_DIR_IN	cbi(LM311_OUT_DDR,LM311_OUT_BIT);
#define LM311_OUT_HIGH		sbi(LM311_OUT_OUT,LM311_OUT_BIT);
#define LM311_OUT_LOW		cbi(LM311_OUT_OUT,LM311_OUT_BIT);
#define LM311_OUT_TEST		LM311_OUT_IN & ( 1 << LM311_OUT_BIT)
*/



// LCD/OLED-E
#define DISPLAY_E_OUT				PORTC
#define DISPLAY_E_IN				PINC
#define DISPLAY_E_DDR				DDRC
#define DISPLAY_E_BIT				2

#define DISPLAY_E_DIR_OUT			sbi(DISPLAY_E_DDR,DISPLAY_E_BIT);
#define DISPLAY_E_DIR_IN			cbi(DISPLAY_E_DDR,DISPLAY_E_BIT);
#define DISPLAY_E_HIGH				sbi(DISPLAY_E_OUT,DISPLAY_E_BIT);
#define DISPLAY_E_LOW				cbi(DISPLAY_E_OUT,DISPLAY_E_BIT);
#define DISPLAY_E_TEST				DISPLAY_E_IN & ( 1 << DISPLAY_E_BIT)

// LCD/OLED-RS
#define DISPLAY_RS_OUT				PORTB
#define DISPLAY_RS_IN				PINB
#define DISPLAY_RS_DDR				DDRB
#define DISPLAY_RS_BIT				2

#define DISPLAY_RS_DIR_OUT			sbi(DISPLAY_RS_DDR,DISPLAY_RS_BIT);
#define DISPLAY_RS_DIR_IN			cbi(DISPLAY_RS_DDR,DISPLAY_RS_BIT);
#define DISPLAY_RS_HIGH				sbi(DISPLAY_RS_OUT,DISPLAY_RS_BIT);
#define DISPLAY_RS_LOW				cbi(DISPLAY_RS_OUT,DISPLAY_RS_BIT);
#define DISPLAY_RS_TEST				DISPLAY_RS_IN & ( 1 << DISPLAY_RS_BIT)


// LCD/OLED-R\-W
#define DISPLAY_RW_OUT				PORTB
#define DISPLAY_RW_IN				PINB
#define DISPLAY_RW_DDR				DDRB
#define DISPLAY_RW_BIT				4

#define DISPLAY_RW_DIR_OUT			sbi(DISPLAY_RW_DDR,DISPLAY_RW_BIT);
#define DISPLAY_RW_DIR_IN			cbi(DISPLAY_RW_DDR,DISPLAY_RW_BIT);
#define DISPLAY_RW_HIGH				sbi(DISPLAY_RW_OUT,DISPLAY_RW_BIT);
#define DISPLAY_RW_LOW				cbi(DISPLAY_RW_OUT,DISPLAY_RW_BIT);
#define DISPLAY_RW_TEST				DISPLAY_RW_IN & ( 1 << DISPLAY_RW_BIT)

/*
// LCD/OLED-LED
#define DISPLAY_LED_OUT			PORTC
#define DISPLAY_LED_IN			PINC
#define DISPLAY_LED_DDR			DDRC
#define DISPLAY_LED_BIT			3

#define DISPLAY_LED_DIR_OUT		sbi(DISPLAY_LED_DDR,DISPLAY_LED_BIT);
#define DISPLAY_LED_DIR_IN		cbi(DISPLAY_LED_DDR,DISPLAY_LED_BIT);
#define DISPLAY_LED_HIGH		sbi(DISPLAY_LED_OUT,DISPLAY_LED_BIT);
#define DISPLAY_LED_LOW			cbi(DISPLAY_LED_OUT,DISPLAY_LED_BIT);
#define DISPLAY_LED_TEST		DISPLAY_LED_IN & ( 1 << DISPLAY_LED_BIT)
*/

#define DISPLAY_PORT_OUT			PORTC
#define DISPLAY_PORT_IN				PINC
#define DISPLAY_PORT_DDR			DDRC
#define DISPLAY_PORT_OFFSET			4

#define DISPLAY_PORT_DIR_OUT		DISPLAY_PORT_DDR = DISPLAY_PORT_DDR | ( 0x0f << DISPLAY_PORT_OFFSET);
#define DISPLAY_PORT_DIR_IN			DISPLAY_PORT_DDR = DISPLAY_PORT_DDR & ( ~(0x0f << DISPLAY_PORT_OFFSET));
#define DISPLAY_PORT_WRITE(nibble)	DISPLAY_PORT_OUT = ( DISPLAY_PORT_OUT & ( ~(0x0f << DISPLAY_PORT_OFFSET ))) | ((nibble & 0x0f) << DISPLAY_PORT_OFFSET);
#define DISPLAY_PORT_READ			(( DISPLAY_PORT_IN >> DISPLAY_PORT_OFFSET ) & 0x0f)

#endif