
/*
 * Interrupts.s
 *
 * Created: 03.05.2014 23:27:38
 *  Author: DL8NCI
 */ 


 #include <avr/io.h>
 #include "Hardware.h"
 #include "Mega32Aux.h"

 
.global INT1_vect
	INT1_vect:

		; set the diagnosis port
;		sbi		_SFR_IO_ADDR(PORTA),0

		; R24 to stack
		push	r24

		; setup/start TC2
		ldi		r24, WGM2_normal_bm | COM2_non_PWM_toggle_bm | CS2_div_1_bm
		out		_SFR_IO_ADDR(TCCR2), r24

		; start TC1
		ldi		r24, WGM1_B_CTC_bm | CS1_T1_rising_bm
		out		_SFR_IO_ADDR(TCCR1B), r24

		; and now SREG to stack
;		in		r24, _SFR_IO_ADDR(SREG)
;		push	r24

		; no INT1-interrupt any more
;		in		r24,_SFR_IO_ADDR(GICR)
;		andi	r24,!INT1_bm
		ldi		r24,0x00
		out		_SFR_IO_ADDR(GICR),r24

		; clear pending interrupts
		ldi		r24,INTF1_bm
		out		_SFR_IO_ADDR(GIFR),r24

		; restore stack and R24
;		pop		r24
;		out		_SFR_IO_ADDR(SREG), r24
		pop		r24

;		cbi		_SFR_IO_ADDR(PORTA),0

		reti


;ISR(INT1_vect) {
;	TCCR2 = WGM2_normal_bm | COM2_non_PWM_toggle_bm | CS2_div_1_bm;
;	TCCR1B = WGM1_B_CTC_bm | CS1_T1_rising_bm;
;	cbi(GICR,7);
;	TCNT1 = 1;
;	sbi(PORTA,0);	
;	}





.global TIMER1_COMPB_vect
	TIMER1_COMPB_vect:

	; R24 to stack
	push	r24;

	; stop TC2 and thus TC0 
	ldi		r24, WGM2_normal_bm | COM2_non_PWM_toggle_bm | CS2_no_clock_bm
	out		_SFR_IO_ADDR(TCCR2),r24

	; and now SREG to stack
	in		r24, _SFR_IO_ADDR(SREG)
	push	r24

	; switch off OCIE1B-interrupt
    in		r24, _SFR_IO_ADDR(TIMSK)
    andi	r24, !OCIE1B_bm
	out		_SFR_IO_ADDR(TIMSK), r24
	
	; ready = 1;
    ldi		r24, 0x01
    sts		ready, r24


	; cbi(PORTA,0); - diagnosis
    cbi		_SFR_IO_ADDR(PORTA), 0	; 27

	; restore stack and R24
    pop		r24
    out		_SFR_IO_ADDR(SREG), r24
    pop		r24
    reti


.global TIMER0_OVF_vect
	TIMER0_OVF_vect:
	
	sei;
	
	; cbi(PORTA,0); - diagnosis
    ;cbi		_SFR_IO_ADDR(PORTA), 0	; 27

	; R24 and SREG to stack
	push	r24;
	in		r24, _SFR_IO_ADDR(SREG)
	push	r24

	lds		r24,mn2
	subi	r24,0xff
	sts		mn2,r24

	; restore SREG and R24
    pop		r24
    out		_SFR_IO_ADDR(SREG), r24
    pop		r24

	; cbi(PORTA,0); - diagnosis
    ;sbi		_SFR_IO_ADDR(PORTA), 0	; 27

    reti
