/*=============================================================================*
 * USART.c - provides driver for USART.                                        *
 * Copyright (C) 2008  Matthias Jordan, DL8NCI                                 *
 * For more information see <http://www.dl8nci.de>                             *
 *=============================================================================*
 * This program is free software; you can redistribute it and/or modify it     *
 * under the terms of the GNU General Public License as published by the Free  *
 * Software Foundation; either version 3 of the License, or (at your option)   *
 * any later version.                                                          *
 *                                                                             *
 * This program is distributed in the hope that it will be useful, but WITHOUT *
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       *
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for    *
 * more details.                                                               *
 *                                                                             *
 * You should have received a copy of the GNU General Public License along     *
 * with this program; if not, see <http://www.gnu.org/licenses/>.              *
 *-----------------------------------------------------------------------------*
 * Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der *
 * GNU General Public License, wie von der Free Software Foundation            *
 * verffentlicht, weitergeben und/oder modifizieren, entweder gem Version 3 *
 * der Lizenz oder (nach Ihrer Option) jeder spteren Version.                 *
 *                                                                             *
 * Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen *
 * von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die         *
 * implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR EINEN         *
 * BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.     *
 *                                                                             *
 * Sie sollten ein Exemplar der GNU General Public License zusammen mit        *
 * diesem Programm erhalten haben. Falls nicht,                                *
 * siehe <http://www.gnu.org/licenses/>.                                       *
 *=============================================================================*/




#include "USART.h"
#include "Hardware.h"

#include <avr/io.h>
#include <stdio.h>


void USART_Out(uint8_t c) {
	while ( !( UCSRA & (1<<UDRE)) );
	UDR = c;
	}

int USART_SendChar(char c, FILE *stream) {
	USART_Out(c);
	return 0;
	}



void USART_Init(void) {

//	USART_RTS_DIR_OUT
//	USART_RTS_LOW
	
//	USART_CTS_LOW
//	USART_CTS_DIR_IN

// Sets Baudrate to 19200 baud
	UBRRH=0;
	UBRRL=(unsigned long)F_CPU/((unsigned long)9600<<4)-1;

// TX enable, RX enable; no interrupts;  5..8 bit
	UCSRB=0x18;		//0b0001 1000

// UCSRC-Select, async mode, no parity, 1 stop bit, 8 data bit
	UCSRC=0x86;		//0b1000 0110

	}
	
void USART_SetStdOut(void) {
	// in order to utilize printf
	static FILE mystdout = FDEV_SETUP_STREAM(USART_SendChar,NULL,_FDEV_SETUP_WRITE);
	stdout = &mystdout;
	}

